Private Sub heat1_Click()

'**********************************************************************
'     DIFFUSION EQUATION   EULER EXPLICIT METHOD                      *
'**********************************************************************
    Const NX = 51
    Dim U(NX) As Double
    Dim UU(NX) As Double
    Dim KX As Integer
    Dim MX As Integer
    Dim dT As Double
    Dim DX As Double
    Dim R As Double
    Dim IH, I5, J, K, N As Integer
            
    KX = 20 'Input number of mesh. (40)
    MX = KX + 1
    KM = 1000 'Input number of time steps. (1000)
    dT = 0.00025 'Input time increment DELTA T. (0.00025)
    
    DX = 1# / (MX - 1)
    R = dT / DX ^ 2
    IH = (MX + 1) / 2
    I5 = 0.05 / dT
    If I5 = 0 Then I5 = 1

    '**** INITIAL CONDITION
    For I = 1 To MX
        U(I) = 1#
    Next I

    '**** MAIN LOOP
    For K = 1 To KM
        U(1) = 0#
        U(MX) = 0#

        For I = 2 To MX - 1
            UU(I) = R * U(I - 1) + (1# - 2 * R) * U(I) + R * U(I + 1)
        Next I
        For I = 2 To MX - 1
            U(I) = UU(I)
        Next I
        
        If Abs(U(IH)) >= 10000 Then
            ErrMsg "G[", "DIVERGE!"
            Exit For
        End If
    Next K
       
End Sub
