Private Sub heat2_Click()

'**********************************************************************
'     2 dimensional heat equation  -- Euler explicit method           *
'**********************************************************************
    Const NX = 51
    Const NY = 51
    Dim U(NX, NY) As Double
    Dim UU(NX, NY) As Double
    Dim KX, KY As Integer
    Dim MX, MY As Integer
    Dim dT As Double
    Dim NLAST As Integer
    Dim DX, DY As Double
    Dim R1, R2 As Double
    Dim J, K, N As Integer
            
    KX = 20: KY = 20 'Input number of mesh for X & Y direction(<50) (20,20)
    MX = KX + 1: MY = KY + 1
    dT = 0.0005 'Input time increment dT  (.0005)
    NLAST = 400 'Input number of time step  (400)
    
    DX = 1# / (MX - 1)
    DY = 1# / (MY - 1)
    R1 = dT / DX ^ 2
    R2 = dT / DY ^ 2
    For K = 1 To MX
        For J = 1 To MX
            U(K, J) = 0#
            UU(K, J) = 0#
        Next J
    Next K
'***  Time Marching
    For N = 1 To NLAST
 
        '***  Boundary Condition
        For K = 1 To MY
            U(1, K) = 40#
            U(MX, K) = 0#
        Next K
        For J = 1 To MX
            U(J, 1) = 80#
            U(J, MY) = 0#
        Next J
        
        '***  Euler explicit Method
        For K = 2 To MY - 1
            For J = 2 To MX - 1
                UU(J, K) = U(J, K) + R1 * (U(J + 1, K) - 2# * U(J, K) + U(J - 1, K)) _
                    + R2 * (U(J, K + 1) - 2# * U(J, K) + U(J, K - 1))
            Next J
        Next K
        For K = 2 To MY - 1
            For J = 2 To MX - 1
                U(J, K) = UU(J, K)
            Next J
        Next K
   
    Next N
    
End Sub
